
/**
 * Module exports
 */

module.exports = exports = IE;

/**
 * Version.
 */

exports.version = '0.0.1';

/**
 * Module dependencies.
 */

var jade = require('jade')
  , nodes = jade.nodes
  , Compiler = jade.Compiler

/**
 * Add `template` filter.
 */

jade.filters.ie = function (block, compiler, params) {
  return new IE(block, compiler, params || {}).compile();
};

/**
 * Compiler constructor.
 *
 * @see http://msdn.microsoft.com/en-us/library/ms537512%28VS.85%29.aspx
 * @api public
 */

function IE (block, compiler, params) {
  Compiler.call(this, block, compiler.options);

  var version = Object.keys(params)[0];

  if (undefined == version) {
    version = 'IE';
  } else if ('!' == version) {
    version = '!IE';
  } else {
    version = version.toString();

    // convert numbers to (number)
    version = version.replace(/([\d\.]+)/g, '(IE $1)');

    // removes spaces after !
    version = version.replace(/! +/g, '!')

    // converts signs to proper keywords
    version = version.replace(/< \(I/, '(lt I');
    version = version.replace(/> \(I/, '(gt I');
    version = version.replace(/<= \(I/, '(lte I');
    version = version.replace(/>= \(I/, '(gte I');

    // make sure to remove needless parenthesis
    if (version.indexOf('(') == version.lastIndexOf('(') 
     && !~version.indexOf('!('))
      version = version.replace(/\(/, '').replace(/\)/, '')
  }

  block.unshift(new nodes.Text('<!--[if ' + version + ']>'));
  block.push(new nodes.Text('<![endif]-->'));
}

/**
 * Inherit from Compiler
 */

IE.prototype.__proto__ = Compiler.prototype;
