
/**
 * Test dependencies.
 */

var should = require('should')
  , jade = require('jade')
  , jadevu = require('./jade-ie')
  , vm = require('vm')
  , fs = require('fs')

/**
 * Tests.
 */

console.log('Testing that compiling a template includes the wrapper');

jade.compile("ie:\n  script(src='woot.js')")()
  .should.eql('<!--[if IE]>\n<script src="woot.js"></script><![endif]-->\n');

jade.compile("ie('!'):\n  script(src='woot.js')")()
  .should.eql('<!--[if !IE]>\n<script src="woot.js"></script><![endif]-->\n');

jade.compile("ie(7):\n  script(src='woot.js')")()
  .should.eql('<!--[if IE 7]>\n<script src="woot.js"></script><![endif]-->\n');

jade.compile("ie('!7'):\n  script(src='woot.js')")()
  .should.eql('<!--[if !(IE 7)]>\n<script src="woot.js"></script><![endif]-->\n');

jade.compile("ie('! 7'):\n  script(src='woot.js')")()
  .should.eql('<!--[if !(IE 7)]>\n<script src="woot.js"></script><![endif]-->\n');

jade.compile("ie('7 | 8'):\n  script(src='woot.js')")()
  .should.eql('<!--[if (IE 7) | (IE 8)]>\n<script src="woot.js"></script><![endif]-->\n');

jade.compile("ie('< 7 | > 8'):\n  script(src='woot.js')")()
  .should.eql('<!--[if (lt IE 7) | (gt IE 8)]>\n<script src="woot.js"></script><![endif]-->\n');

jade.compile("ie('< 7 & > 8'):\n  script(src='woot.js')")()
  .should.eql('<!--[if (lt IE 7) & (gt IE 8)]>\n<script src="woot.js"></script><![endif]-->\n');

jade.compile("ie('< 7'):\n  script(src='woot.js')")()
  .should.eql('<!--[if lt IE 7]>\n<script src="woot.js"></script><![endif]-->\n');

jade.compile("ie('< 8'):\n  script(src='woot.js')")()
  .should.eql('<!--[if lt IE 8]>\n<script src="woot.js"></script><![endif]-->\n');

jade.compile("ie('<= 7'):\n  script(src='woot.js')")()
  .should.eql('<!--[if lte IE 7]>\n<script src="woot.js"></script><![endif]-->\n');

jade.compile("ie('<= 8'):\n  script(src='woot.js')")()
  .should.eql('<!--[if lte IE 8]>\n<script src="woot.js"></script><![endif]-->\n');
